//06-02-2015 aggiunto invio temperatura soglia
//---------------------------------------------------
// LIBRERIA LCD
//---------------------------------------------------
#include "U8glib.h"

//---------------------------------------------------
// LIBRERIE MYSENSORS
//---------------------------------------------------
#include <MySensor.h>
#include <SPI.h>

//---------------------------------------------------
// LIBRERIE EMON
//---------------------------------------------------
#define RF69_COMPAT 0  // define this to use the RF69 driver i.s.o. RF12
#include <JeeLib.h>
#include <RTClib.h>                 // Real time clock (RTC) - used for software RTC to reset kWh counters at midnight
#include <Wire.h>                   // Part of Arduino libraries - needed for RTClib
RTC_Millis RTC;

//--------------------------------------------------------------------------------------------
// RFM12B Settings
//--------------------------------------------------------------------------------------------
#define myNodeID   29          //node ID of Rx (range 0-30) 
#define network    210      //network group (can be in the range 1-250).
#define RF_freq    RF12_868MHZ     //Freq of RF12B can be RF12_433MHZ, RF12_868MHZ or RF12_915MHZ. Match freq to module

//---------------------------------------------------
// emonGLCD SETUP
//---------------------------------------------------
const int emonTx_NodeID       = 10;       //emonTx node ID strasmissione dati nel garage
const int emonTh_NodeID       = 18;       //emonTh node ID temp esterna
const int RaspberryTx_NodeID  = 15;        //Raspberry node ID serve per il tempo

const int PV_gen_offset = 50;         // When generation drops below this level generation will be set to zero - used to force generation level to zero at night
int ore = 0, minuti = 0, secondi = 0; 
double usekwh = 0, genkwh = 0, diffkwh = 0;
double usekwhOld = 0, genkwhOld = 0, diffkwhOld = 0;
double use_history[7], gen_history[7];
int cval_use, cval_gen;
double differenza =0, differenzaold =0;

//-------------------------------------------------------------------------------------------- 
// Flow control
//-------------------------------------------------------------------------------------------- 
unsigned long last_emontx;                   // Used to count time from last emontx update
unsigned long last_emonbase;                   // Used to count time from last emontx update
boolean last_switch_state, switch_state; 
unsigned long fast_update, slow_update, long_update;

//-------------------------------------------------------------------------------------------- 
// strutture PayloadTX Emon
//-------------------------------------------------------------------------------------------- 
typedef struct { int power1, power2, power3, Vrms; } PayloadTX;         // neat way of packaging data for RF comms
PayloadTX emontx;

typedef struct { int temperature, caldaia, sogliacaldaia, kwusetoday, kwconstoday; } PayloadGLCD;
PayloadGLCD emonglcd;

typedef struct { int temperature, batteria; } PayloadTH;
PayloadTH emonth;

//-------------------------------------------------------------------------------------------- 
// LCD
//-------------------------------------------------------------------------------------------- 
U8GLIB_ST7920_128X64 u8g(13, 11, 12, U8G_PIN_NONE);
int statoLCD=0;

//-------------------------------------------------------------------------------------------- 
// sensore temperatura
//-------------------------------------------------------------------------------------------- 
#include <OneWire.h>
#include <DallasTemperature.h>
#define DS18B20_PIN 28 // Data wire is plugged into port 2 on the Arduino
#define DS18B20_PIN_ON_OFF 26
OneWire oneWire(DS18B20_PIN); // Setup a oneWire instance to communicate with any OneWire devices (not just Maxim/Dallas temperature ICs)
DallasTemperature sensors(&oneWire); // Pass our oneWire reference to Dallas Temperature.
DeviceAddress sensor; // arrays to hold device address

//-------------------------------------------------------------------------------------------- 
// led bottoni etc
//-------------------------------------------------------------------------------------------- 
#define LED_CALDAIA_PIN  24  // Arduino Digital I/O pin number for relay #define outPin 2
#define LED_VERDE_PIN    30  // Arduino Digital I/O pin number for relay #define outPin 2
#define LED_ROSSO_PIN    32  // Arduino Digital I/O pin number for relay #define outPin 2
#define RELAY_PIN        5  // Arduino Digital I/O pin number for relay #define outPin 2
#define BUTTON_PIN_PIU   7  // Arduino Digital I/O pin number for button #define tempP 0
#define BUTTON_PIN_MENO  6  // Arduino Digital I/O pin number for button #define tempM 1
#define BUTTON_PIN_MENU  22  // Arduino Digital I/O pin number for button
#define BUZZER_PIN       36
#define PIN_LCD_RETRO    34  //attiva disattiva la retroilluminazione

//-------------------------------------------------------------------------------------------- 
// termostato
//-------------------------------------------------------------------------------------------- 
float temp, maxtemp, mintemp;
int tempSoglia = 14;
int tempSogliaOld = 0;
int tempVera = 0;
int tempVeraOld = 0;
double isteresi = 0.2;
int statoCaldaia = 0;
int statoCaldaiaOld = 1;
double temp_ext;

//-------------------------------------------------------------------------------------------- 
// MYSENSORS SETUP
//-------------------------------------------------------------------------------------------- 
#define NODE_ID_MYSENSORS 8
#define SN_MYSENSORS "Selion Control"
#define SV_MYSENSORS "5.2"  

#define RADIO_CE_PIN 46 // radio chip enable
#define RADIO_SPI_SS_PIN 47 // radio SPI serial select
MySensor gw(RADIO_CE_PIN, RADIO_SPI_SS_PIN);

#define CHILD_ID_HEATER 0

//termostato a vera
MyMessage msgHeater(CHILD_ID_HEATER, V_HEATER_SW);
MyMessage msgTemp(CHILD_ID_HEATER, V_TEMP);
MyMessage msgTempSetPoint(CHILD_ID_HEATER, V_HEATER);
//termostato a vera

#define CHILD_ID_WATT_CONS 1
#define CHILD_ID_WATT_PROD 2

//corrente a vera
MyMessage msgCons(CHILD_ID_WATT_CONS,V_WATT);
MyMessage msgkwhCons(CHILD_ID_WATT_CONS,V_KWH);
MyMessage msgProd(CHILD_ID_WATT_PROD,V_WATT);
MyMessage msgkwhProd(CHILD_ID_WATT_PROD,V_KWH);
//corrente a vera

//conteggio accensione caldaia
int use_caldaia[7];
int tot_caldaia = 0;


// variabili di test
String pippo, pippo1;


void setup() 
{
      //Serial.begin(9600); 
    
      Serial.println("AVVIO");
    
      //avvio mysensors
      // mysensors    
      gw.begin(incomingMessage, NODE_ID_MYSENSORS, false);    //nodo 8
      gw.sendSketchInfo(SN_MYSENSORS, SV_MYSENSORS);
      gw.present(CHILD_ID_HEATER, S_HEATER);
      gw.present(CHILD_ID_WATT_CONS, S_POWER);
      gw.present(CHILD_ID_WATT_PROD, S_POWER);
      //mysensors
    
      //inizializza la radio emon
      delay(500); 				   //wait for power to settle before firing up the RF
      rf12_initialize(myNodeID,RF_freq,network);   //Initialize RFM12 with settings defined above      
      delay(100);
        
      Serial.println("RF12B demo Receiver - Simple demo"); 
      
      Serial.print("Node: "); 
      Serial.print(myNodeID); 
      Serial.print(" Freq: "); 
      if (RF_freq == RF12_433MHZ) Serial.print("433Mhz");
      if (RF_freq == RF12_868MHZ) Serial.print("868Mhz");
      if (RF_freq == RF12_915MHZ) Serial.print("915Mhz");  
      Serial.print(" Network: "); 
      Serial.println(network);
    
      // inizializza bottoni led etc
      pinMode(LED_CALDAIA_PIN, OUTPUT); 
      pinMode(LED_VERDE_PIN, OUTPUT); 
      pinMode(LED_ROSSO_PIN, OUTPUT); 
      pinMode(RELAY_PIN,OUTPUT);
      pinMode(BUTTON_PIN_PIU,INPUT);
      pinMode(BUTTON_PIN_MENO,INPUT);
      pinMode(BUTTON_PIN_MENU,INPUT);  
      pinMode(BUZZER_PIN, OUTPUT);      
      Serial.println("Inizializzati bottoni");
      // inizizalizza bottoni led etc
    
      //testa funzionamento led  etc
      digitalWrite(LED_CALDAIA_PIN, HIGH);    
      digitalWrite(LED_VERDE_PIN, HIGH); 
      digitalWrite(LED_ROSSO_PIN, HIGH); 
      delay(100);
      digitalWrite(LED_VERDE_PIN, LOW);
      digitalWrite(LED_CALDAIA_PIN, LOW);
      digitalWrite(LED_ROSSO_PIN, LOW);
      sirena(BUZZER_PIN);
      Serial.println("test bottoni");
      //testa funzionamento led  etc
    
      // mysensors 
      //inizializza vera
      //invia temperatura e soglia a vera    
      tempVera = (int) temp;
      gw.send(msgTemp.set(tempVera));
      gw.send(msgTempSetPoint.set(tempSoglia));
      gw.send(msgHeater.set("Off")); 

    
      //monitor
      if ( u8g.getMode() == U8G_MODE_R3G3B2 ) 
      {
        u8g.setColorIndex(255);     // white
      }
      else if ( u8g.getMode() == U8G_MODE_GRAY2BIT ) 
      {
        u8g.setColorIndex(3);         // max intensity
      }
      else if ( u8g.getMode() == U8G_MODE_BW ) 
      {
        u8g.setColorIndex(1);         // pixel on
      }
      else if ( u8g.getMode() == U8G_MODE_HICOLOR ) 
      {
        u8g.setHiColorByRGB(255,255,255);
      }
      //monitor
    
      //DS18B20
      pinMode(DS18B20_PIN_ON_OFF,OUTPUT); // DS18B20 power control pin - see jumper setup instructions above
      digitalWrite(DS18B20_PIN_ON_OFF,HIGH); // turn on DS18B20
      delay(10);    
      sensors.begin();
      if (!sensors.getAddress(sensor, 0)) 
      {
        Serial.println("Unable to find DS18B20 Temperature Sensor");
      }
      //DS18B20        
      
      
      //statoLCD = 4;  //visualizza solo stato mysensors  
      pippo = "CIAO";
      pippo1 = "MIAO";
}



void loop() {
    
      //mysensors
      gw.process();
      //mysensors
    
      //DS18B20    
      digitalWrite(DS18B20_PIN_ON_OFF,HIGH); 
      delay(2); // turn on DS18B20 and wait for it to come online
      sensors.requestTemperatures(); // Send the command to get temperatures
      temp = (sensors.getTempCByIndex(0));
      digitalWrite(DS18B20_PIN_ON_OFF,LOW);  
      mintemp = temp; 
      maxtemp = temp;          // reset min and max
      //DS18B20
    
      //Serial.print("letta temparatura: ");
      //Serial.println(temp);
     
      //emon riceve i dati dalla radio emon                
      if (rf12_recvDone())
      {
          if (rf12_crc == 0 && (rf12_hdr & RF12_HDR_CTL) == 0)  // and no rf errors
          {
                int node_id = (rf12_hdr & 0x1F);
                
                if (node_id == emonTx_NodeID) 
                {
                    emontx = *(PayloadTX*) rf12_data; 
                    last_emontx = millis();
                    
                    Serial.println("Arrivato emontx");
                }
                
                if (node_id == RaspberryTx_NodeID)
                {
                    RTC.adjust(DateTime(2013, 1, 1, rf12_data[1], rf12_data[2], rf12_data[3]));
                    last_emonbase = millis();
                    Serial.println("Arrivato RTC adjust");
                } 
                
                if (node_id == emonTh_NodeID)
                {
                    emonth = *(PayloadTH*) rf12_data;
                    Serial.println("Arrivato emonth");
                }
          }
          else
          {
                 //Serial.println("ERRORE 1");
          }
           
      }  
      else
      {
          //Serial.println("ERRORE 2");      
      }
      //emon riceve i dati dalla radio emon

    
          
      //--------------------------------------------------------------------------------------------
      // Display update every 200ms
      //--------------------------------------------------------------------------------------------      
      if ((millis() - fast_update)>200)      
      {            
            fast_update = millis();
            
            DateTime now = RTC.now();
            int last_hour = ore;
            ore = now.hour();
            minuti = now.minute();
            secondi = now.second();
            //Serial.print(" ore: "); 
            //Serial.println(ore);
            
           // Serial.print(" minuti: "); 
           // Serial.println(minuti);
            
            //3.600.000 millisecondi corrisponde ad una ora in millisecondi
            /*
            usekwh += (emontx.power1 * 0.2) / 3600000;
            genkwh += (emontx.power2 * 0.2) / 3600000;
            */
            usekwh += (emontx.power1 * 0.8) / 3600;
            genkwh += (emontx.power2 * 0.2) / 3600;
            
           // Serial.print(" usekwh: "); 
           // Serial.println(usekwh);
            
           // Serial.print(" genkwh: "); 
          //  Serial.println(genkwh);
        
            if (last_hour == 23 && ore == 00) 
            { 
                int i; for (i=6; i>0; i--) gen_history[i] = gen_history[i-1]; 
                genkwh = 0;
                for(i=6; i>0; i--) use_history[i] = use_history[i-1];
                usekwh = 0;   
                for (i=6; i>0; i--) use_caldaia[i] = use_caldaia[i-1]; 
                tot_caldaia = 0;        
            }
        
            gen_history[0] = genkwh;
            use_history[0] = usekwh;
            use_caldaia[0] = tot_caldaia;
            
            cval_use = cval_use + (emontx.power1 - cval_use)*0.50;
            cval_gen = cval_gen + (emontx.power2 - cval_gen)*0.50;
            
           // Serial.print(" cval_use: "); 
           // Serial.println(cval_use);
        
           // Serial.print(" cval_gen: "); 
           // Serial.println(cval_gen);
            
            if (cval_gen<PV_gen_offset) cval_gen=0;                  //set generation to zero when generation level drops below a certian level (at night) eg. 20W
            
            //legge temperatura esterna
            temp_ext = emonth.temperature;
    
    
            
      }   
      //emon  Display update every 200ms

      
      //stato LCD
      if (statoLCD==0)
      {                         
          u8g.firstPage();
          do 
          {
              //void draw_solar_page(int use, int gen, double kwuse, double kwgen, int Tsoglia, float TTemp, boolean TStatoCaldaia, int TExt, double ore, double minuti, double mintemp, double maxtemp)
              draw_solar_page(cval_use, cval_gen, usekwh, genkwh, tempSoglia, temp, statoCaldaia, temp_ext, ore, minuti, maxtemp, mintemp);
          } 
          while( u8g.nextPage() );                     
      }
              
      if (statoLCD==1)
      {         
          u8g.firstPage();
          do 
          {        
            draw_thermostat(tempSoglia, temp, statoCaldaia, temp_ext, ore, minuti, tot_caldaia);      
          } 
          while(u8g.nextPage());                          
      }  
      
      if (statoLCD==2)
      {         
          u8g.firstPage();
          do 
          {     
             draw_history_page (gen_history, use_history);                 
          } 
          while(u8g.nextPage());                          
      }  
        
      if (statoLCD==3)
      {         
          u8g.firstPage();
          do 
          {    
             //void draw_stato(long Tlast_emontx, long Tlast_emonbase, long Tfast_update, long Tslow_update, double Thour, double Tminute, double Tusekwh, double Tgenkwh)                
             //draw_stato(last_emontx, last_emonbase, fast_update, slow_update, ore, minuti, secondi, usekwh, genkwh);      
             draw_history_caldaia(use_caldaia);
          } 
          while(u8g.nextPage());                          
      }  
        
      if (statoLCD==4)
      {         
          u8g.firstPage();
          do 
          {                 
             draw_stato_mysensors(pippo, pippo1);      
          } 
          while(u8g.nextPage());                          
      }                 
      //stato LCD
        
              
      //led consumo
      differenza = cval_gen - cval_use;
      //stati corrente led ed allarni
      if (differenza>0) 
      {
          //la produzione supera il consumo            
          digitalWrite(LED_ROSSO_PIN, LOW);
          digitalWrite(LED_VERDE_PIN, HIGH);                  
      } 
      else 
      {                     
          //il consumo supera la produzione 
          digitalWrite(LED_ROSSO_PIN, HIGH);
          digitalWrite(LED_VERDE_PIN, LOW); 
      }
      //led consumo
   
      //BUZZER_PIN
      if (-differenza > 2999)  
      {            
          //manda segnale che si puo sfruttare piu corrente > 1.5 kw
          //Serial.println("consumo moltissimo > 3000");  
          sirena(BUZZER_PIN);
          //Avvisa con un bip
      }
      //BUZZER_PIN 
      
            
      //stato bottoni                        
      if(digitalRead(BUTTON_PIN_MENU) == HIGH)
      {
         //sistema lo stato della schermata del monitor
         statoLCD++;
         if ( statoLCD > 4) 
         {
           statoLCD = 0;  //toglie lo stato inizializzazione
         }
         Serial.print("PREMUTO BOTTONE STATO statoLCD: ");
         Serial.println(statoLCD);
         //sistema lo stato della schermata del monitor 
    
         delay(100); //test antirimbalzo     
      } 
         
      if(digitalRead(BUTTON_PIN_MENO) == HIGH)
      {          
         statoLCD = 1;  //visualizza solo stato caldaia       
         decrementaSoglia();
   
         Serial.println("PREMUTO -");
         
         delay(100); //test antirimbalzo
      } 
  
      if(digitalRead(BUTTON_PIN_PIU) == HIGH)
      {       
        statoLCD = 1;  //visualizza solo stato caldaia
        incrementaSoglia();
        
        Serial.println("PREMUTO +");
        
        delay(100); //test antirimbalzo
      } 
     //stato bottoni
         
   

       
      //invia dati caldaia a emon ogni 10 secondi
      if ((millis()-slow_update)>10000)
      {
          slow_update = millis();
          //typedef struct { int temperature, umidita, caldaia; } PayloadGLCD; 
          emonglcd.temperature = (int) (temp * 100);                     // set emonglcd payload temperature -- > temp int
          emonglcd.caldaia = (int) (statoCaldaia * 1000);                // set emonglcd payload caldaia --> statoCaldaia 0-1
          emonglcd.sogliacaldaia = (int) (tempSoglia * 100);             // invia la temperatura impostata
          emonglcd.kwusetoday = (int) (usekwh * 1000);  
          emonglcd.kwconstoday = (int) (genkwh * 1000);  
          
          rf12_sendNow(0, &emonglcd, sizeof emonglcd);                   //send temperature data via RFM12B using new rf12_sendNow wrapper -glynhudson
          rf12_sendWait(2); 
          Serial.println("##############");
          Serial.println("invio dati a emoncms");
          Serial.print("temp: "); 
          Serial.println(temp); 
          Serial.print("statoCaldaia: "); 
          Serial.println(statoCaldaia);   
          Serial.println("##############");
      
          //calcola la temperatura minima e massima
          if (temp > maxtemp) maxtemp = temp;
          if (temp < mintemp) mintemp = temp;  
      
          //Serial.print(" maxtemp: "); 
          //Serial.println(maxtemp);
            
          //Serial.print(" mintemp: "); 
          //Serial.println(mintemp);
      }
      //invia dati caldaia a emon
    
   
      //Conteggio ogni 60 secondi
      if ((millis()-long_update)>60000)
      {
          long_update = millis();
        
          if ( statoCaldaia == 1) 
          {
             tot_caldaia = tot_caldaia + 1;  //aggiunge un minuto allo stato acceso caldaia
          }  

          if ( (statoLCD == 1) || (statoLCD == 2) || (statoLCD == 3) || (statoLCD == 4)) 
          {
             statoLCD = 0;  //dopo 20 secondi va di nuovo allo stato 0
          }  
      }
      //Conteggio ogni 60 secondi
   
         
      //invia dati a vera su consumo corrente      
      if(differenza<-PV_gen_offset || differenza>PV_gen_offset) //invia se la differenza e almeno di 30w
      {

           //invia solo se i dati differiscono almeno di 50 w
           if(differenza - differenzaold < -PV_gen_offset || differenza - differenzaold > PV_gen_offset)
           {      
                //Serial.println("##############");
                //Serial.println("invio dati a vera");
                gw.send(msgCons.set(cval_use));  // Send watt value to gw        
                gw.send(msgProd.set(cval_gen));  // Send kwh value to gw
                
                double kwh;        
                kwh = use_history[0] * 10;
                gw.send(msgkwhCons.set(kwh,2));  // Send kwh value to gw     
                //Serial.print("kwh cons: "); 
                //Serial.println(kwh); 
                
                kwh = gen_history[0] * 10;
                gw.send(msgkwhProd.set(kwh,2));  // Send kwh value to gw
        
                differenzaold = differenza;
            }
      }
      //invia dati a vera su consumo corrente  
  
      relayCaldaia(); //altrimenti non scatta il rele alla temperatura prefissata
    
      //invia dati a vera temperatura
      tempVera = (int) temp;    
      if (tempVeraOld != tempVera)      
      {  
          Serial.print("temp:");
          Serial.println(temp);
          gw.send(msgTemp.set(tempVera));
          Serial.print("inviata nuova temperatura a vera:");
          Serial.println(tempVera);
          tempVeraOld = tempVera;
      }              
      //invia dati a vera temperatura
}


void decrementaSoglia()
{ 
    statoLCD = 1;  //visualizza solo stato caldaia   
    
    tempSoglia = tempSoglia - 1; // decrementa il valore di tempSoglia
        
    gw.send(msgTempSetPoint.set(tempSoglia)); //invia il nuovo valore a vera
    
    relayCaldaia();  
}

void incrementaSoglia()
{ 
    statoLCD = 1;  //visualizza solo stato caldaia   
    tempSoglia = tempSoglia + 1; //incrementa il valore di tempSoglia    
    
    gw.send(msgTempSetPoint.set(tempSoglia)); //invia il nuovo valore a vera
    
    relayCaldaia();
}

void relayCaldaia()
{
  if(temp < tempSoglia)  //accendi caldaia
  {
     //accende la caldaia
     if(statoCaldaia == 0)  //accendi caldaia
     {     
       digitalWrite(RELAY_PIN, HIGH);
       digitalWrite(LED_CALDAIA_PIN, HIGH);
       statoCaldaia = 1;  
       gw.send(msgHeater.set("HeatOn"),true);  //invia HeatOn  a vera      
      }   
   }
     

   if(temp >= tempSoglia + isteresi)
   {
     if(statoCaldaia == 1)  //accendi caldaia
     {     
       digitalWrite(RELAY_PIN, LOW);
       digitalWrite(LED_CALDAIA_PIN, LOW);
       statoCaldaia = 0;
       gw.send(msgHeater.set("Off"),true); //invia Off  a Vera   
      }           
   }
   
   if(tempSoglia != tempSogliaOld)
   {
      gw.send(msgHeater.set(tempSoglia),true);
      if(statoCaldaia == 1)  //accendi caldaia
      {            
         gw.send(msgHeater.set("HeatOn"),true); //invia HeatOn  a Vera   
      } 
      else 
      {            
         gw.send(msgHeater.set("Off"),true); //invia Off  a Vera   
      }  
      
      tempSogliaOld = tempSoglia;     
   }
   
   delay(50);
}



void sirena (int targetPin)
{
    //analogWrite(6,100);
    //analogWrite(9,0);
    tone(targetPin,466,800);
    delay(400);
    //analogWrite(9,100);
    //analogWrite(6,0);
    //delay(400);
    //analogWrite(6,100);
    //analogWrite(9,0);
    tone(targetPin,622,800);
    delay(400);
    //analogWrite(9,100);
    //analogWrite(6,0);
    //delay(400);  
}


void incomingMessage(const MyMessage &message) 
{
    
    //Serial.print("message.type:");
    //Serial.println(message.type);
     
    //Serial.print("message.data:");
    //Serial.println(message.data);
    
    // We only expect one type of message from controller. But we better check anyway.
    if (message.isAck()) 
    {
        Serial.println("This is an ack from gateway");
        //pippo = "This is an ack from gateway";
        //statoLCD = 4;  //visualizza solo stato mysensors 
    }        
     
    // Check for Heater Switch Message
    if (message.type==V_HEATER_SW) 
    {     
        //Serial.print("message.data:");
        //Serial.println(message.data);
    
        // Switch Heater On
        if (strncmp (message.data,"HeatOn",6) == 0)
        {
                                 
           pippo = " ARRIVATO PULSANTE ON VERA";
           //statoLCD = 4;  //visualizza solo stato mysensors 
           //delay(100);  
            //gw.send(msgHeater.set("HeatOn"),true);            
        }
    
        // Switch Heater Off
        if (strncmp (message.data,"Off",3) == 0)
        {            
           pippo = " ARRIVATO PULSANTE OFF VERA";
           //statoLCD = 4;  //visualizza solo stato mysensors 
           //delay(100); 
            //gw.send(msgHeater.set("Off"),true);
        }   
    } 

    if (message.type==V_HEATER) 
    {
        // Check for Temperature Up/Down Message
        int heatLvl = atoi(message.data);
        //Serial.println("ARRIVATO PULSANTE + - VERA");        
        
        //Serial.print("heatLvl:");
        //Serial.println(heatLvl);         
        
        pippo = " ARRIVATO PULSANTE + - VERA";
        //statoLCD = 4;  //visualizza solo stato mysensors 
        //delay(100); 
           
        if ( heatLvl > tempSoglia) 
        {
            Serial.println("heatLvl > tempSoglia");
            int tmpsoglia = tempSoglia;
            for (int i=tmpsoglia; i < heatLvl; i++)
            {
                incrementaSoglia();
            } 
        }
        
        if ( heatLvl < tempSoglia) 
        {
            Serial.println("heatLvl < tempSoglia");
            int tmpsoglia = tempSoglia;
            for (int i=heatLvl; i < tmpsoglia; i++)
            {
                decrementaSoglia();                            
            } 
        }

    }
    
}

